︠e7d55ccc-abe8-44ee-b373-534fd9867916s︠
help()
︡92679f9a-e06d-4eea-b65e-14424ed84f09︡{"md":"\n## Welcome to Sage 8.4!\n\n- **Online documentation:** [View the Sage documentation online](http://www.sagemath.org/doc/).\n\n- **Help:** For help on any object or function, for example `matrix_plot`, enter `matrix_plot?` followed by tab or shift+enter.  For help on any module (or object or function), for example, `sage.matrix`, enter `help(sage.matrix)`.\n\n- **Tab completion:** Type `obj` followed by tab to see all completions of obj.  To see all methods you may call on `obj`, type `obj.` followed by tab.\n\n- **Source code:** Enter `matrix_plot??` followed by tab or shift+enter to look at the source code of `matrix_plot`.\n\n- **License information:** For license information about Sage and its components, enter `license()`."}︡{"done":true}︡
︠c50a2a5a-34dd-4265-a712-824a1b58f121s︠
is_prime?
︡62dc9efe-0abf-45d4-aa77-8805dd949fd8︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/sage-8.4_1804/local/lib/python2.7/site-packages/sage/arith/misc.py\nSignature : is_prime(n)\nDocstring :\nReturn \"True\" if n is a prime number, and \"False\" otherwise.\n\nUse a provable primality test or a strong pseudo-primality test\ndepending on the global \"arithmetic proof flag\".\n\nINPUT:\n\n* \"n\" - the object for which to determine primality\n\nSee also:\n\n  * \"is_pseudoprime()\"\n\n  * \"sage.rings.integer.Integer.is_prime()\"\n\nAUTHORS:\n\n* Kevin Stueve kstueve@uw.edu (2010-01-17): delegated calculation\n  to \"n.is_prime()\"\n\nEXAMPLES:\n\n   sage: is_prime(389)\n   True\n   sage: is_prime(2000)\n   False\n   sage: is_prime(2)\n   True\n   sage: is_prime(-1)\n   False\n   sage: is_prime(1)\n   False\n   sage: is_prime(-2)\n   False\n\n   sage: a = 2**2048 + 981\n   sage: is_prime(a)    # not tested - takes ~ 1min\n   sage: proof.arithmetic(False)\n   sage: is_prime(a)    # instantaneous!\n   True\n   sage: proof.arithmetic(True)"}}︡{"done":true}
︠079a1a3c-3f06-47c7-a7ac-e76831e2b9ccs︠
# test if a number is prime
is_prime(5)
︡0550f0d4-ada6-4cf5-ad2e-862d2c381123︡{"stdout":"True\n"}︡{"done":true}
︠54cdc87d-16b2-4384-ad9a-31d813c5b1ads︠
#arithemtic
print 2^3 + 2 * 5 - 3
print "2^(2^3) equals",2^(2^3)
︡8750a488-19ff-4099-94e3-292f4915ade7︡{"stdout":"15\n"}︡{"stdout":"2^(2^3) equals 256\n"}︡{"done":true}︡
︠2537417d-a3b1-494f-9251-13f2da6432b0s︠
#list of primes
list = prime_range(100)
print "There are",len(list),"primes less than 100"
︡458da575-df5f-4d5f-93a4-dbc25af188de︡{"stdout":"There are 25 primes less than 100\n"}︡{"done":true}︡
︠95fa2833-bb0e-432a-9058-9a7fe08d0b72s︠
#a way to access things in a list
for n in list:
    if n% 4 == 1:
        print n
︡c9abcf0c-c3ea-4c1c-af84-5fb253d9b185︡{"stdout":"5\n13\n17\n29\n37\n41\n53\n61\n73\n89\n97\n"}︡{"done":true}︡
︠742e601c-c059-4b89-8b36-4ffb4c7f5beas︠
# building a new list
list2 = [ p^2 for p in list]
list2
︡ae083bf6-ebc3-441b-9f0c-b8e2427c70e4︡{"stdout":"[4, 9, 25, 49, 121, 169, 289, 361, 529, 841, 961, 1369, 1681, 1849, 2209, 2809, 3481, 3721, 4489, 5041, 5329, 6241, 6889, 7921, 9409]\n"}︡{"done":true}︡
︠0985077f-ad0f-40f6-8c80-97a7891a72aas︠
#how many times does 7921 appear in list2?

list2.count(7921)
︡d7d28049-07ab-430d-93e4-c01c4f066772︡{"stdout":"1\n"}︡{"done":true}︡
︠8cfbedab-bb5c-4d25-8bf7-daf027c26a16s︠
#do arithmetic modulo n
#find an inverse of 5 moduloe 7

Mod(5,7)^(-1)
︡c5db0fcf-2407-46a0-ad85-7fd565a2f0f1︡{"stdout":"3\n"}︡{"done":true}
︠be84af8d-6a6e-44c2-a4a3-894af6a51a2bs︠
R = Integers(7)

for a in R:
    print a,a^2
︡84486794-e268-409c-9aa5-fcd75ed8db87︡{"stdout":"0 0\n1 1\n2 4\n3 2\n4 2\n5 4\n6 1\n"}︡{"done":true}
︠40129b80-725c-4f1c-99ba-c4522d5aca77s︠
#Solving Linear Diophantine Equations
#xgcd returns gcd(a,b), plus x and y that solve ax+by = gcd(a,b)

xgcd(5,7)
︡f4420668-ff34-4ef0-9a58-9579fc734b9f︡{"stdout":"(1, 3, -2)\n"}︡{"done":true}
︠aa2fbf4a-87a1-4340-9931-36558924e8c8s︠
5*3 + 7 * (-2)
︡2ac23e39-8f30-432a-b702-9541c49b179e︡{"stdout":"1\n"}︡{"done":true}
︠59cfaa04-61ec-4845-aa2f-2264b5bdd1dc︠
#x \equiv a \pmod{n} and x \equiv b \pmod{m}
#crt(a,b,n,m)
crt(5,6,11,13)
︡a4089600-8094-4fa2-8388-2a2d5b3907e8︡{"stdout":"71\n"}︡{"done":true}
︠36ef678b-3e9d-4888-bfee-dde12ebc36d2s︠
#squares modulo n

is_square(Mod(2^2,101))
︡cc686a66-c674-4021-8410-06149bb3692f︡{"stdout":"True"}︡{"stdout":"\n"}︡{"done":true}
︠9673b2c5-233f-4c7e-9620-5e9b73c4b60es︠
is_square(Mod(2,101))
︡adc3240a-6a16-47b5-add1-5a2af78b59d3︡{"stdout":"False\n"}︡{"done":true}
︠e71185a1-383a-41a2-88ba-a33b01c5f7cfs︠
#primitive roots and order

Mod(2,101).multiplicative_order()
︡de8c2a51-1bc2-4d3b-8df8-4a9640c105d8︡{"stdout":"100\n"}︡{"done":true}
︠07827da5-1a69-42d3-999b-34abe6866e4as︠
primitive_root(101)
︡76259683-a393-43b0-9420-76661b73d16c︡{"stdout":"2\n"}︡{"done":true}
︠c11e4270-c02b-4154-88bd-deb9acb3f522s︠
def encode(s):
    s = str(s)
    return sum(ord(s[i])*256^i for i in range(len(s)))

def decode(n):
    n = Integer(n)
    v= []
    while n!=0 :
        v.append(chr(n %256))
        n//= 256 # replaces n by floor(n/256)
    return ''.join(v)
︡3553f4ed-651d-4bef-8747-d70f1b7960f1︡{"done":true}
︠5fd60581-3f21-4311-9159-7017d3356740s︠
m = encode('I like number theory')
m
︡d18cf468-3c9a-4ed8-aed5-34682c53b6b5︡{"stdout":"693339872193417233970224178043240443845515419721\n"}︡{"done":true}
︠3038709d-9948-46c1-8940-a8e331207becs︠
decode(m)
︡40aee1c5-9b3a-4189-a9cf-30120b8a8163︡{"stdout":"'I like number theory'\n"}︡{"done":true}
︠76826f58-e8dd-47f3-9195-ba36e15e5045︠
#large powers, efficiently
Mod(3,10003)^10454838383
︡1dd75123-aa5f-4dfa-8416-54c708f71a67︡{"stdout":"341\n"}︡{"done":true}
︠7078cd7b-7163-4d8d-bf88-6e54d3ed512cs︠
#Gaussian Integers
ZZ[I]

︡0aadf53d-4e18-4b08-9521-c7283d8090ad︡{"stdout":"Order in Number Field in I with defining polynomial x^2 + 1"}︡{"stdout":"\n"}︡{"done":true}
︠e9ca97b5-e80a-4156-a39f-a03694cf8884︠
a = ZZ[I](5)
factor(a)
︡e400dd4c-9c8a-4736-86e0-4e4a9f8d973a︡{"stdout":"(I) * (-I - 2) * (2*I + 1)\n"}︡{"done":true}
︠7254e82e-312d-480c-94c4-7fe059dab251︠

︡e1f73bef-3395-4637-9a39-b0433db60968︡{"done":true}
︠99179e80-24ca-4ac5-bd98-1beae5b5301es︠
(2 + I) *(3-I)
︡8f194388-23c4-4102-9c0d-a646d1af0b1b︡{"stdout":"I + 7\n"}︡{"done":true}
︠207ea8de-47cd-4d85-a70f-252a2d78c832s︠
continued_fraction(e)
︡3aec287f-f4e5-48d6-b342-941cac09d4c5︡{"stdout":"[2; 1, 2, 1, 1, 4, 1, 1, 6, 1, 1, 8, 1, 1, 10, 1, 1, 12, 1, 1, ...]"}︡{"stdout":"\n"}︡{"done":true}
︠790b9788-8b11-47c0-a937-379ebb1e917c︠

︡87371bfb-a47d-453a-9098-be41a2283d2f︡
︠d9abbc7d-ea74-4e36-b6fc-972796a25f68s︠
cf = continued_fraction([2,5,4,3,2,7])
cf.convergents()
︡e088ed30-9add-4a9c-8cd1-4b378334b1eb︡{"stdout":"[2, 11/5, 46/21, 149/68, 344/157, 2557/1167]\n"}︡{"done":true}
︠0454e6fe-ebd3-446e-9447-67b6ae66c897︠









